Index: trunk/ab5.0/abdev/abdev/Backup.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/Backup.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/Backup.cpp	(revision 625)
@@ -48,5 +48,5 @@
 	sprintf(temp2,"%x\r\n",hOwner);
 
-	for(i=0;i<MAX_WNDNUM;i++){
+	for(i=0;i<MdiInfo.size();i++){
 		if(MdiInfo[i].hwnd){
 			int WndNum;
@@ -60,5 +60,5 @@
 
 			//情報を追加
-			sprintf(temp2+lstrlen(temp2),"%s\r\n",MdiInfo[WndNum].path);
+			sprintf(temp2+lstrlen(temp2),"%s\r\n",MdiInfo[WndNum].path.c_str());
 
 			iNum++;
@@ -115,7 +115,5 @@
 
 		//パスを変更
-		GlobalFree(MdiInfo[WndNum].path);
-		MdiInfo[WndNum].path=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(szBeforeFilePath)+1);
-		lstrcpy(MdiInfo[WndNum].path,szBeforeFilePath);
+		MdiInfo[WndNum].path = szBeforeFilePath;
 
 		//ドキュメント セレクト コンボボックスに挿入
Index: trunk/ab5.0/abdev/abdev/Caret.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/Caret.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/Caret.cpp	(revision 625)
@@ -122,5 +122,4 @@
 	// 選択範囲（バッファインデックス）を取得
 	//////////////////////////////////////////
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	pCharRange->cpMin=GetBufferIndexFromCaretPos(
@@ -149,5 +148,4 @@
 }
 void TextEdit_GetSelText(int WndNum,CHARRANGE *pCharRange,char *buffer){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	memcpy(buffer,
@@ -158,5 +156,4 @@
 
 void GetScrollBaseCaretPos(int WndNum,int *pNaturalBaseX,int *pNaturalBaseY){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	HWND hEdit;
@@ -176,5 +173,4 @@
 
 void GetNaturalBaseCaretPos(int WndNum,int *pScrollBaseX,int *pScrollBaseY){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	HWND hEdit;
@@ -194,5 +190,4 @@
 
 void TextEdit_SetSel(int WndNum,int StartIndex,int EndIndex,BOOL bShowCenter){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	GetCaretPosFromBufferIndex(
@@ -216,5 +211,4 @@
 }
 void TextEdit_SelectOneLine(int WndNum,int code_pos,BOOL bShowCenter){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	///////////////////////
@@ -235,5 +229,4 @@
 void ResetCaretPos(int WndNum,BOOL bInputAndReset){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int x,y;
 
@@ -465,5 +458,4 @@
 }
 BOOL TextEdit_ScrollCaret(int WndNum,BOOL bScrollOneStep_x,BOOL bShowCenter){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int x,y;
 	BOOL bScroll=0;
@@ -537,5 +529,4 @@
 
 void CaretPos_LooseToNatural(int WndNum,int loose_x,int loose_y,POINT *pCaretPos){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,LastPos;
 	int x,y;
@@ -650,5 +641,4 @@
 	/////////////////////////////
 
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	//ピクセル座標をカーソル座標（文字単位）に変更
@@ -664,5 +654,4 @@
 	///////////////////////////
 
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	int x,y;
@@ -719,5 +708,4 @@
 	///////////////////////////
 
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	char *pBuf;
@@ -773,5 +761,4 @@
 	// キャレット移動（上キー）
 	///////////////////////////
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	if(pCaretPos->y==0){
@@ -795,5 +782,4 @@
 	// キャレット移動（下キー）
 	///////////////////////////
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	//上下のキャレット移動時には、左右方向の位置を保持する
@@ -812,5 +798,4 @@
 	// キャレット移動（PageUpキー）
 	///////////////////////////////
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	if(pCaretPos->y==0){
@@ -839,5 +824,4 @@
 	// キャレット移動（PageUpキー）
 	///////////////////////////////
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	//上下のキャレット移動時には、左右方向の位置を保持する
Index: trunk/ab5.0/abdev/abdev/ChildWndOnRebar.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/ChildWndOnRebar.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/ChildWndOnRebar.cpp	(revision 625)
@@ -40,5 +40,4 @@
 LRESULT CALLBACK DocComboProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
 	extern WNDPROC OldDocComboProc;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	char str[MAX_PATH];
@@ -48,5 +47,5 @@
 			if(HIWORD(wParam)==CBN_SELCHANGE){
 				SendMessage(hwnd,CB_GETLBTEXT,SendMessage(hwnd,CB_GETCURSEL,0,0),(long)str);
-				for(i=0;i<MAX_WNDNUM;i++){
+				for(i=0;i<MdiInfo.size();i++){
 					if(lstrcmpi(str,MdiInfo[i].title)==0) break;
 				}
@@ -181,5 +180,4 @@
 	extern WNDPROC OldDocComboProc;
 	extern HFONT hStatusFont;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	HWND hTempWnd;
@@ -200,5 +198,5 @@
 	hTempWnd=GetWindow(hClient,GW_CHILD);
 	if(IsWindow(hTempWnd)){
-		for(i=0,i2=0;i<MAX_WNDNUM;i++){
+		for(i=0,i2=0;i<MdiInfo.size();i++){
 			if(MdiInfo[i].hwnd){
 				GetWindowText(MdiInfo[i].hwnd,buffer,MAX_PATH);
Index: trunk/ab5.0/abdev/abdev/ClassTree.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/ClassTree.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/ClassTree.cpp	(revision 625)
@@ -444,13 +444,15 @@
 }
 void SetClassTreeFromOneFile(char *lpszFilePath,int iFileNum){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int WndNum;
 	HWND hChild=GetWindow(hClient,GW_CHILD);
 	while(hChild){
 		WndNum=GetWndNum(hChild);
-		if(IS_DOCUMENT_TEXT(MdiInfo[WndNum].DocType)){
-			if(lstrcmpi(MdiInfo[WndNum].path,lpszFilePath)==0) break;
-		}
-		hChild=GetNextWindow(hChild,GW_HWNDNEXT);
+		if( WndNum != -1 )
+		{
+			if(IS_DOCUMENT_TEXT(MdiInfo[WndNum].DocType)){
+				if(lstrcmpi(MdiInfo[WndNum].path.c_str(),lpszFilePath)==0) break;
+			}
+			hChild=GetNextWindow(hChild,GW_HWNDNEXT);
+		}
 	}
 
Index: trunk/ab5.0/abdev/abdev/Common.h
===================================================================
--- trunk/ab5.0/abdev/abdev/Common.h	(revision 624)
+++ trunk/ab5.0/abdev/abdev/Common.h	(revision 625)
@@ -258,6 +258,4 @@
 struct RAD_UNDOSTATE_NAME{
 	std::string name;
-	std::string HandleName;
-	char *CallBackName;
 };
 #define RAD_UNDO_INSERTWND	1
@@ -357,5 +355,5 @@
 	int DocType;
 	char *title;
-	char *path;
+	std::string path;
 
 	union{
@@ -368,5 +366,5 @@
 	char *IndentStr;
 };
-extern MDIINFO MdiInfo[MAX_WNDNUM];
+extern std::vector<MDIINFO> MdiInfo;
 
 //RADツールのマウスドラッグ
@@ -483,8 +481,4 @@
 #define EVENTTYPE_MMSYS		2
 
-//ウィンドウ タイプ
-#define WNDTYPE_DEFAULT		0
-#define WNDTYPE_MODALDLG	1
-#define WNDTYPE_MODELESSDLG	3
 
 struct NEWPROJECTINFO{
@@ -648,5 +642,5 @@
 char *ReadBuffer( const std::string &path );
 char *ReadBuffer_NonErrMsg( const std::string &path );
-_int8 WriteBuffer(const std::string &path,char *buffer,int length, bool isEnableError = true);
+_int8 WriteBuffer(const std::string &path,const char *buffer,int length, bool isEnableError = true);
 _int8 WriteBuffer_NonErrMsg(const std::string &path,char *buffer,int length);
 void GetRelationalPath(char *path,char *dir);
@@ -738,5 +732,5 @@
 void SetupWindow(HWND hwnd);
 BOOL SetRunning(HWND hChild);
-BOOL IsNeedCompile(char *FileName,BOOL bDebug);
+BOOL IsNeedCompile( const std::string &filepath, BOOL bDebug );
 std::string GetLastErrorString();
 
@@ -875,5 +869,5 @@
 
 	void add(char *path);
-	void insert(char *path);
+	void insert(const char *path);
 
 	void ResetFileMenu(CSubMenuEx *pobj_SubMenu,BOOL bOwnerDraw);
@@ -969,9 +963,10 @@
 
 //WindowControl.cpp
-int GetWndInfoNum(char *name);
-ActiveBasic::PM::WindowInfo *GetWndInfo( char *name );
+int GetWndInfoNum( const std::string &name );
+ActiveBasic::PM::WindowInfo *GetWndInfo( const std::string &name );
 HGLOBAL Rad_GetChildInfoClipboardData(int WndNum,int WndInfoNum);
 void Rad_PasteChildInfoClipboardData(int WndNum,HGLOBAL hGlobal);
 char *PermutationWndPgmTemplate(char *pBuf,const char *pPjName, char *pWndName, char *pHandleName, char *pProcName);
+const std::string PermutationWndPgmTemplate( const std::string &templateFilePath, const std::string &projectName, std::string &windowName, std::string &handleName, std::string &procName );
 void GetItemClassName(char *buffer,int Control);
 void SaveWindowProgram();
@@ -1057,5 +1052,5 @@
 
 //MenuProc.cpp
-int GetMenuInfoNum(const char *name);
+int GetMenuInfoNum(const std::string &name);
 void HeapMenuDataFree(MENU_INFO *pMenuInfo,int ItemNum,int *NumberOfFreedItem);
 BOOL CALLBACK DlgProject_MenuID_Input(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
Index: trunk/ab5.0/abdev/abdev/Complement.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/Complement.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/Complement.cpp	(revision 625)
@@ -388,5 +388,4 @@
 	iControlTabSpace=MdiInfo[WndNum].pMdiTextEdit->iWidth_ControlTabSpace;
 
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	extern int font_width,font_height;
 	POINT pos;
@@ -612,5 +611,4 @@
 
 LRESULT CALLBACK ComplementListViewProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	extern COMPLEMENT_WINDOW_INFO ComplementWndInfo;
 	int i,WndNum;
Index: trunk/ab5.0/abdev/abdev/Debugger.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/Debugger.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/Debugger.cpp	(revision 625)
@@ -251,5 +251,5 @@
 
 		char temporary[MAX_PATH];
-		sprintf(temporary,"\"%s\",%d",MdiInfo[WndNum].path,MdiInfo[WndNum].pMdiTextEdit->StartCaretPos.y);
+		sprintf(temporary,"\"%s\",%d",MdiInfo[WndNum].path.c_str(),MdiInfo[WndNum].pMdiTextEdit->StartCaretPos.y);
 
 		char temp2[MAX_PATH];
@@ -281,5 +281,5 @@
 //////////////////////////
 
-CFileBreakPoint::CFileBreakPoint(char *lpszFileName,int iLineNum){
+CFileBreakPoint::CFileBreakPoint(const char *lpszFileName,int iLineNum){
 	this->lpszFileName=(char *)HeapAlloc(hHeap,0,lstrlen(lpszFileName)+1);
 	lstrcpy(this->lpszFileName,lpszFileName);
@@ -389,5 +389,5 @@
 	HeapDefaultFree(ppItem);
 }
-void CDBBreakPoint::insert(char *lpszFileName,int iLineNum){
+void CDBBreakPoint::insert( const char *lpszFileName,int iLineNum){
 	int i;
 	for(i=0;i<num;i++){
@@ -404,5 +404,5 @@
 	}
 }
-void CDBBreakPoint::remove(char *lpszFileName,int iLineNum){
+void CDBBreakPoint::remove( const char *lpszFileName,int iLineNum){
 	int i;
 	for(i=0;i<num;i++){
@@ -429,9 +429,12 @@
 	if(WndNum==-1) return;
 
-	if(!IsExistFile(MdiInfo[WndNum].path)) return;
+	if( !Jenga::Common::Path( MdiInfo[WndNum].path ).IsExistFile() )
+	{
+		return;
+	}
 
 	int i,i2,sw=0;
 	for(i=0;i<num;i++){
-		if(lstrcmpi(MdiInfo[WndNum].path,ppItem[i]->lpszFileName)==0){
+		if(lstrcmpi(MdiInfo[WndNum].path.c_str(),ppItem[i]->lpszFileName)==0){
 			for(i2=0;i2<ppItem[i]->num;i2++){
 				if(MdiInfo[WndNum].pMdiTextEdit->StartCaretPos.y==ppItem[i]->piLine[i2]){
@@ -446,9 +449,9 @@
 	if(sw==0){
 		//ブレークポイントを追加
-		insert(MdiInfo[WndNum].path,MdiInfo[WndNum].pMdiTextEdit->StartCaretPos.y);
+		insert(MdiInfo[WndNum].path.c_str(),MdiInfo[WndNum].pMdiTextEdit->StartCaretPos.y);
 	}
 	else{
 		//ブレークポイントを削除
-		remove(MdiInfo[WndNum].path,MdiInfo[WndNum].pMdiTextEdit->StartCaretPos.y);
+		remove(MdiInfo[WndNum].path.c_str(),MdiInfo[WndNum].pMdiTextEdit->StartCaretPos.y);
 	}
 
@@ -500,5 +503,5 @@
 
 
-CFileBreakPoint *CDBBreakPoint::EnumLines(char *lpszFilePath){
+CFileBreakPoint *CDBBreakPoint::EnumLines(const char *lpszFilePath){
 	int i;
 	for(i=0;i<num;i++){
@@ -510,5 +513,5 @@
 }
 
-void CDBBreakPoint::replace(LPSTR lpszFilePath,LPSTR lpszBuffer,CHARRANGE *pDelRange,CHARRANGE *pRange,LPSTR lpszNewStr){
+void CDBBreakPoint::replace(const char *lpszFilePath,LPSTR lpszBuffer,CHARRANGE *pDelRange,CHARRANGE *pRange,LPSTR lpszNewStr){
 	int i;
 	for(i=0;i<num;i++){
Index: trunk/ab5.0/abdev/abdev/Debugger.h
===================================================================
--- trunk/ab5.0/abdev/abdev/Debugger.h	(revision 624)
+++ trunk/ab5.0/abdev/abdev/Debugger.h	(revision 625)
@@ -53,5 +53,5 @@
 	int num;
 
-	CFileBreakPoint(char *lpszFileName,int iLineNum);
+	CFileBreakPoint(const char *lpszFileName,int iLineNum);
 	~CFileBreakPoint();
 
@@ -72,12 +72,12 @@
 	~CDBBreakPoint();
 
-	void insert(char *lpszFileName,int iLineNum);
-	void remove(char *lpszFileName,int iLineNum);
+	void insert( const char *lpszFileName,int iLineNum);
+	void remove( const char *lpszFileName,int iLineNum);
 
 	void Event_BreakPoint(void);
 	void SaveToTempFile(void);
 
-	CFileBreakPoint *EnumLines(char *lpszFilePath);
+	CFileBreakPoint *EnumLines(const char *lpszFilePath);
 
-	void replace(LPSTR lpszFilePath,LPSTR lpszBuffer,CHARRANGE *pDelRange,CHARRANGE *pRange,LPSTR lpszNewStr);
+	void replace(const char *lpszFilePath,LPSTR lpszBuffer,CHARRANGE *pDelRange,CHARRANGE *pRange,LPSTR lpszNewStr);
 };
Index: trunk/ab5.0/abdev/abdev/DocumentAdvice.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/DocumentAdvice.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/DocumentAdvice.cpp	(revision 625)
@@ -179,11 +179,10 @@
 
 #define MEM_SPACE 1024 //強制終了を防ぐためのゆとりスペース
-			extern MDIINFO MdiInfo[MAX_WNDNUM];
-			for(i3=0;i3<MAX_WNDNUM;i3++){
+			for(i3=0;i3<MdiInfo.size();i3++){
 				if(MdiInfo[i3].hwnd){
-					if(lstrcmpi(temporary,MdiInfo[i3].path)==0) break;
-				}
-			}
-			if(i3==MAX_WNDNUM){
+					if(lstrcmpi(temporary,MdiInfo[i3].path.c_str())==0) break;
+				}
+			}
+			if(i3==MdiInfo.size()){
 				//ファイルから開く
 				HANDLE fh;
Index: trunk/ab5.0/abdev/abdev/DrawBuffer.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/DrawBuffer.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/DrawBuffer.cpp	(revision 625)
@@ -193,9 +193,9 @@
 			if( projectInfo.IsOpened() ){
 				pobj_FileBreakPoint=
-					projectInfo.pobj_DBBreakPoint->EnumLines(MdiInfo[m_WndNum].path);
+					projectInfo.pobj_DBBreakPoint->EnumLines(MdiInfo[m_WndNum].path.c_str());
 			}
 			else{
 				extern CDBBreakPoint *pobj_DBBreakPoint;
-				pobj_FileBreakPoint=pobj_DBBreakPoint->EnumLines(MdiInfo[m_WndNum].path);
+				pobj_FileBreakPoint=pobj_DBBreakPoint->EnumLines(MdiInfo[m_WndNum].path.c_str());
 			}
 
@@ -266,5 +266,4 @@
 
 void TextEdit_DrawBuffer(HDC hdc,int WndNum){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	int x,y;
Index: trunk/ab5.0/abdev/abdev/DrawWindow.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/DrawWindow.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/DrawWindow.cpp	(revision 625)
@@ -4,5 +4,4 @@
 
 void DrawLineInClient(int WndNum,long StartX,long StartY,long EndX,long EndY){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	MoveToEx(MdiInfo[WndNum].MdiRadInfo->hMemDC,
 		StartX+MdiInfo[WndNum].MdiRadInfo->ClientPos.x,
@@ -14,5 +13,4 @@
 }
 void DrawRectangleInClient(int WndNum,long left,long top,long right,long bottom,COLORREF RGB_Pen,COLORREF RGB_Brush,BOOL bBrushing){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HPEN hPen,hOldPen;
 	HBRUSH hBrush,hOldBrush;
@@ -36,5 +34,4 @@
 }
 void DrawButtonEdge(int WndNum,POINT *pPos,SIZE *pSize){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HPEN hPen,hOldPen;
 
@@ -86,5 +83,4 @@
 }
 void DrawItemEdgeByExStyle(int WndNum,int ExStyle,POINT *pPos,SIZE *pSize){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HPEN hPen,hOldPen;
 	RECT rect;
@@ -172,5 +168,4 @@
 }
 void DrawScrollBar(int WndNum,DWORD style,BOOL bSwitch,POINT *pPos,SIZE *pSize){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	HPEN hPen,hOldPen;
@@ -487,5 +482,4 @@
 }
 void DrawUpDownControl(int WndNum,DWORD style,BOOL bSwitch,POINT *pPos,SIZE *pSize){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	HPEN hPen,hOldPen;
@@ -688,5 +682,4 @@
 }
 void DesigningWindow(int WndNum,HDC hdc,POINT *pBasePos,const ActiveBasic::PM::WindowInfo *pWindowInfo){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3,i4;
 	double red,green,blue,d_red,d_green,d_blue;
@@ -1773,5 +1766,4 @@
 }
 void DrawRadWindow(int WndNum,const ActiveBasic::PM::WindowInfo *pWindowInfo){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HBRUSH hOldBrush;
 	POINT pos;
Index: trunk/ab5.0/abdev/abdev/ExtensionLink.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/ExtensionLink.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/ExtensionLink.cpp	(revision 625)
@@ -197,8 +197,9 @@
 }
 
-COLORREF CExtLink::GetTabColorFromFilePath(char *path){
+COLORREF CExtLink::GetTabColorFromFilePath( const std::string &filepath )
+{
 	//拡張子を識別し、タブの色を決定
 	char szExt[255],*lpszTemp;
-	_splitpath(path,NULL,NULL,NULL,szExt);
+	_splitpath(filepath.c_str(),NULL,NULL,NULL,szExt);
 	if(szExt[0]=='.') lpszTemp=szExt+1;
 	else lpszTemp=szExt;
Index: trunk/ab5.0/abdev/abdev/ExtensionLink.h
===================================================================
--- trunk/ab5.0/abdev/abdev/ExtensionLink.h	(revision 624)
+++ trunk/ab5.0/abdev/abdev/ExtensionLink.h	(revision 625)
@@ -31,5 +31,5 @@
 	void ResetListView(HWND hListView);
 
-	COLORREF GetTabColorFromFilePath(char *path);
+	COLORREF GetTabColorFromFilePath( const std::string &filepath );
 };
 
Index: trunk/ab5.0/abdev/abdev/FileOperation.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/FileOperation.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/FileOperation.cpp	(revision 625)
@@ -57,5 +57,6 @@
 	return buffer;
 }
-_int8 WriteBuffer(const std::string &path,char *buffer,int length, bool isEnableError){
+_int8 WriteBuffer(const std::string &path,const char *buffer,int length, bool isEnableError)
+{
 	HANDLE hFile;
 	DWORD dw;
@@ -328,5 +329,5 @@
 
 	COLORREF TabColor;
-	TabColor=pobj_nv->pobj_ExtLink->GetTabColorFromFilePath(OpenFileName);
+	TabColor=pobj_nv->pobj_ExtLink->GetTabColorFromFilePath( filePath );
 
 	return NewTextEditWindow(OpenFileName,DocumentType,TabColor);
@@ -335,5 +336,4 @@
 	extern LPSTR IconFileFilter;
 	extern HWND hClient,hDocCombo;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int WndNum,i2;
 	char temporary[MAX_PATH],str[MAX_PATH],str2[32];
@@ -380,7 +380,5 @@
 
 			//新しいパスをセット
-			GlobalFree(MdiInfo[WndNum].path);
-			MdiInfo[WndNum].path=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(temporary)+1);
-			lstrcpy(MdiInfo[WndNum].path,temporary);
+			MdiInfo[WndNum].path = temporary;
 
 			//ドキュメント セレクト コンボボックスに挿入
@@ -398,5 +396,5 @@
 		}
 		else{
-			if(MdiInfo[WndNum].path[0]=='\0'){
+			if(MdiInfo[WndNum].path.empty()){
 				//"保存先のファイルを指定してください"
 get_file_path:
@@ -418,5 +416,5 @@
 				return 1;
 			}
-			lstrcpy(temporary,MdiInfo[WndNum].path);
+			lstrcpy(temporary,MdiInfo[WndNum].path.c_str());
 		}
 
@@ -475,7 +473,5 @@
 			}
 			CloseHandle(fh);
-			GlobalFree(MdiInfo[WndNum].path);
-			MdiInfo[WndNum].path=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(temporary)+1);
-			lstrcpy(MdiInfo[WndNum].path,temporary);
+			MdiInfo[WndNum].path = temporary;
 			i2=SendMessage(hDocCombo,CB_FINDSTRINGEXACT,0,(long)MdiInfo[WndNum].title);
 			SendMessage(hDocCombo,CB_DELETESTRING,i2,0);
@@ -489,5 +485,5 @@
 		}
 		else{
-			if(MdiInfo[WndNum].path[0]=='\0'){
+			if(MdiInfo[WndNum].path.empty()){
 				//"保存先のファイルを指定してください"
 				if(!GetFilePathDialog(hOwner,temporary,IconFileFilter,STRING_FILESAVETITLE_DEFAULT,FALSE)) return 0;
@@ -495,5 +491,5 @@
 				return 1;
 			}
-			lstrcpy(temporary,MdiInfo[WndNum].path);
+			lstrcpy(temporary,MdiInfo[WndNum].path.c_str());
 		}
 		SaveIconFile(temporary,hChild);
@@ -515,5 +511,5 @@
 
 	//「最近使ったファイル」を更新
-	pobj_nv->pobj_History->insert(MdiInfo[WndNum].path);
+	pobj_nv->pobj_History->insert(MdiInfo[WndNum].path.c_str());
 
 	return 1;
Index: trunk/ab5.0/abdev/abdev/History.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/History.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/History.cpp	(revision 625)
@@ -57,5 +57,5 @@
 	iNum++;
 }
-void CHistory::insert(char *path){
+void CHistory::insert(const char *path){
 	//重複チェック
 	int i;
Index: trunk/ab5.0/abdev/abdev/IconEditor.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/IconEditor.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/IconEditor.cpp	(revision 625)
@@ -29,5 +29,4 @@
 }
 void ResetIconType(int WndNum){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	HWND hCombo;
@@ -127,5 +126,4 @@
 void AddIconType(int WndNum,int IconType){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,width,BitCount;
 
@@ -192,5 +190,4 @@
 }
 void DeleteIconType(int WndNum){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 
@@ -241,5 +238,4 @@
 	extern HANDLE hHeap;
 	extern HWND hDocCombo;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,IconNum;
 	char str[MAX_PATH],str2[32],*buffer;
@@ -257,5 +253,5 @@
 			i=GetWndNum(hChild);
 			if(MdiInfo[i].DocType==WNDTYPE_ICONEDIT){
-				if(lstrcmpi(MdiInfo[i].path,filepath)==0) break;
+				if(lstrcmpi(MdiInfo[i].path.c_str(),filepath)==0) break;
 			}
 			hChild=GetNextWindow(hChild,GW_HWNDNEXT);
@@ -373,48 +369,50 @@
 
 	//ウィンドウのID登録
-	for(i=0;i<MAX_WNDNUM;i++){
-		if(MdiInfo[i].hwnd==0){
-			MdiInfo[i].hwnd=hChild;
-			MdiInfo[i].DocType=WNDTYPE_ICONEDIT;
-			MdiInfo[i].title=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(str)+1);
-			lstrcpy(MdiInfo[i].title,str);
-			if(filepath){
-				MdiInfo[i].path=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(filepath)+1);
-				lstrcpy(MdiInfo[i].path,filepath);
-			}
-			else MdiInfo[i].path=(char *)GlobalAlloc(GPTR,1);
-
-			MdiInfo[i].MdiIconEditInfo=(MDIICONEDITINFO *)HeapAlloc(hHeap,0,sizeof(MDIICONEDITINFO));
-			MdiInfo[i].MdiIconEditInfo->hMain=hMain;
-			MdiInfo[i].MdiIconEditInfo->hToolDlg=hToolDlg;
-			MdiInfo[i].MdiIconEditInfo->hButtonsDlg=hButtonsDlg;
-			MdiInfo[i].MdiIconEditInfo->hColorDlg=hColorDlg;
-			hdc=GetDC(hMain);
-			MdiInfo[i].MdiIconEditInfo->memdc=CreateCompatibleDC(hdc);
-			MdiInfo[i].MdiIconEditInfo->hMemBmp=CreateCompatibleBitmap(hdc,600,400);
-			SelectObject(MdiInfo[i].MdiIconEditInfo->memdc,MdiInfo[i].MdiIconEditInfo->hMemBmp);
-			ReleaseDC(hMain,hdc);
-
-			MdiInfo[i].MdiIconEditInfo->SelectLevel=0;
-
-			MdiInfo[i].MdiIconEditInfo->num=IconNum;
-			MdiInfo[i].MdiIconEditInfo->SelectIconNum=0;
-			memcpy(MdiInfo[i].MdiIconEditInfo->pIconImage,pImageBuffer,sizeof(DWORD)*IconNum);
-
-			memcpy(MdiInfo[i].MdiIconEditInfo->dwBytesInRes,dwBytesInRes,sizeof(DWORD)*IconNum);
-
-			MdiInfo[i].MdiIconEditInfo->NowTool=IDC_TOOL_PEN;
-			MdiInfo[i].MdiIconEditInfo->MainColor=RGB(0,0,0);
-			extern COLORREF TransparentClrRef;
-			MdiInfo[i].MdiIconEditInfo->SubColor=TransparentClrRef;
-
-			for(i2=0;i2<MdiInfo[i].MdiIconEditInfo->num;i2++){
-				MdiInfo[i].MdiIconEditInfo->undo[i2].NowPos=0;
-				memset(MdiInfo[i].MdiIconEditInfo->undo[i2].lpData,0,sizeof(BYTE *)*MAX_ICONEDIT_UNDONUM);
-			}
-			MdiInfo[i].MdiIconEditInfo->bModify=0;
-			break;
-		}
-	}
+	MdiInfo.push_back( MDIINFO() );
+	i = MdiInfo.size()-1;
+	MdiInfo[i].hwnd=hChild;
+	MdiInfo[i].DocType=WNDTYPE_ICONEDIT;
+	MdiInfo[i].title=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(str)+1);
+	lstrcpy(MdiInfo[i].title,str);
+	if(filepath)
+	{
+		MdiInfo[i].path = filepath;
+	}
+	else
+	{
+		MdiInfo[i].path = "";
+	}
+
+	MdiInfo[i].MdiIconEditInfo=(MDIICONEDITINFO *)HeapAlloc(hHeap,0,sizeof(MDIICONEDITINFO));
+	MdiInfo[i].MdiIconEditInfo->hMain=hMain;
+	MdiInfo[i].MdiIconEditInfo->hToolDlg=hToolDlg;
+	MdiInfo[i].MdiIconEditInfo->hButtonsDlg=hButtonsDlg;
+	MdiInfo[i].MdiIconEditInfo->hColorDlg=hColorDlg;
+	hdc=GetDC(hMain);
+	MdiInfo[i].MdiIconEditInfo->memdc=CreateCompatibleDC(hdc);
+	MdiInfo[i].MdiIconEditInfo->hMemBmp=CreateCompatibleBitmap(hdc,600,400);
+	SelectObject(MdiInfo[i].MdiIconEditInfo->memdc,MdiInfo[i].MdiIconEditInfo->hMemBmp);
+	ReleaseDC(hMain,hdc);
+
+	MdiInfo[i].MdiIconEditInfo->SelectLevel=0;
+
+	MdiInfo[i].MdiIconEditInfo->num=IconNum;
+	MdiInfo[i].MdiIconEditInfo->SelectIconNum=0;
+	memcpy(MdiInfo[i].MdiIconEditInfo->pIconImage,pImageBuffer,sizeof(DWORD)*IconNum);
+
+	memcpy(MdiInfo[i].MdiIconEditInfo->dwBytesInRes,dwBytesInRes,sizeof(DWORD)*IconNum);
+
+	MdiInfo[i].MdiIconEditInfo->NowTool=IDC_TOOL_PEN;
+	MdiInfo[i].MdiIconEditInfo->MainColor=RGB(0,0,0);
+	extern COLORREF TransparentClrRef;
+	MdiInfo[i].MdiIconEditInfo->SubColor=TransparentClrRef;
+
+	for(i2=0;i2<MdiInfo[i].MdiIconEditInfo->num;i2++){
+		MdiInfo[i].MdiIconEditInfo->undo[i2].NowPos=0;
+		memset(MdiInfo[i].MdiIconEditInfo->undo[i2].lpData,0,sizeof(BYTE *)*MAX_ICONEDIT_UNDONUM);
+	}
+	MdiInfo[i].MdiIconEditInfo->bModify=0;
+
+
 
 	//メモリへ初期描画を行う
@@ -449,5 +447,4 @@
 }
 void SaveIconFile(char *filepath,HWND hwnd){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,WndNum;
 	char buffer[8192],temporary[MAX_PATH];
@@ -534,5 +531,4 @@
 LRESULT CALLBACK MDIClientWindow_IconEdit(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
 	extern HWND hDocCombo;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,WndNum;
 
Index: trunk/ab5.0/abdev/abdev/IconEditor_Color.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/IconEditor_Color.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/IconEditor_Color.cpp	(revision 625)
@@ -7,5 +7,4 @@
 BOOL CALLBACK DlgIconColorProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	extern COLORREF TransparentClrRef;
 	int i,i2,WndNum;
Index: trunk/ab5.0/abdev/abdev/IconEditor_Main.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/IconEditor_Main.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/IconEditor_Main.cpp	(revision 625)
@@ -13,5 +13,4 @@
 void LimitRectFormat(int WndNum,RECT *pRect){
 	//はみ出した場合は範囲内におさめる
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	if(pRect->left<0) pRect->left=0;
 	if(pRect->top<0) pRect->top=0;
@@ -33,5 +32,4 @@
 }
 void SetZoomedPixel(HDC hdc,int WndNum,int x,int y){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	POINT pos;
 
@@ -47,5 +45,4 @@
 }
 DWORD GetColorCode(int WndNum,COLORREF ColorRef){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	RGBQUAD *pRgbq;
@@ -70,5 +67,4 @@
 	//////////////////////////////////////////////
 
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HDC hDC;
 	HBITMAP hBmp;
@@ -114,5 +110,4 @@
 	////////////////////////////////////
 
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HDC hDC,hDC2;
 	BITMAP Bitmap;
@@ -147,5 +142,4 @@
 
 void IconEdit_SelectImage(int WndNum){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	SIZE size;
 	HDC hDC;
@@ -169,5 +163,4 @@
 void IconEdit_PasteImage(int WndNum){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3,x,y,y2,selecting_x,selecting_y;
 	DWORD dwRgbq;
@@ -299,5 +292,4 @@
 
 void DrawIconToMemBmp(int WndNum,RECT *pRect){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HPEN hPen,hOldPen;
 	HBRUSH hBrush,hOldBrush;
@@ -406,5 +398,4 @@
 
 void PixelChange(int WndNum,int x,int y,DWORD ColorCode){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	int y2;
@@ -467,5 +458,4 @@
 }
 COLORREF IconEdit_GetPixel(int WndNum,int x,int y){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	int y2;
@@ -525,5 +515,4 @@
 }
 void IconEdit_DrawLine(int WndNum,int x1,int y1,int x2,int y2,DWORD ColorCode){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int dx,dy,s,step;
 
@@ -576,5 +565,4 @@
 }
 void IconEdit_FloodFill(int WndNum,int x,int y,COLORREF FilledColor,DWORD ColorCode){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	if(x<0||y<0) return;
@@ -610,5 +598,4 @@
 }
 void IconEdit_DrawEllipse(int WndNum,int x1,int y1,int x2,int y2,DWORD ColorCode){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	RECT rect,rc2;
 
@@ -680,5 +667,4 @@
 
 void IconEdit_EraseRect(int WndNum,RECT *pRect){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	//変更情報
@@ -698,5 +684,4 @@
 
 void IconEdit_DrawFrame(HWND hwnd,int WndNum,RECT *pRect){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HDC hdc;
 	HPEN hPen,hOldPen;
@@ -744,5 +729,4 @@
 }
 void IconEdit_DrawSelectingRect(HDC hdc,int WndNum){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i2,i3;
 	HPEN hPen,hOldPen;
@@ -817,5 +801,4 @@
 void DrawZoomedBitmap(HDC hdc,int WndNum,POINT *pPos){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int x,y;
 	RGBQUAD rgbq;
@@ -869,5 +852,4 @@
 }
 int IconEdit_GetStateOfDraggingFrame(int WndNum,int x,int y){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	POINT pos;
 	RECT rect;
@@ -892,5 +874,4 @@
 	// 選択されているイメージを表示
 
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HDC hDC2;
 	SIZE size;
@@ -914,5 +895,4 @@
 }
 void TempLine(HDC hdc,int WndNum,int x1,int y1,int x2,int y2,COLORREF ColorRef){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int dx,dy,s,step;
 	HPEN hPen,hOldPen;
@@ -977,5 +957,4 @@
 }
 void TempRectangle(HDC hdc,int WndNum,int x1,int y1,int x2,int y2,COLORREF ColorRef,COLORREF FillClrRef,BOOL bFill){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int x,y;
 	HPEN hPen,hOldPen;
@@ -1038,5 +1017,4 @@
 }
 void TempEllipse(HDC hdc,int WndNum,int x1,int y1,int x2,int y2,COLORREF ColorRef){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HPEN hPen,hOldPen;
 	HBRUSH hBrush,hOldBrush;
@@ -1137,5 +1115,4 @@
 }
 LRESULT CALLBACK IconEditWindowProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int WndNum,dx,dy;
 	BOOL bRedrawMemBmp;
Index: trunk/ab5.0/abdev/abdev/IconEditor_Tool.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/IconEditor_Tool.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/IconEditor_Tool.cpp	(revision 625)
@@ -32,5 +32,4 @@
 
 BOOL CALLBACK DlgIconButtons(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int WndNum;
 	RECT rect;
@@ -105,5 +104,4 @@
 }
 BOOL CALLBACK DlgIconType(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,WndNum;
 	HWND hList;
@@ -180,5 +178,4 @@
 }
 BOOL CALLBACK DlgIconToolProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,WndNum;
 
Index: trunk/ab5.0/abdev/abdev/IconEditor_UndoRedo.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/IconEditor_UndoRedo.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/IconEditor_UndoRedo.cpp	(revision 625)
@@ -4,5 +4,4 @@
 
 void IconEdit_UndoCommand(int WndNum){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	BYTE *pByte;
@@ -40,5 +39,4 @@
 }
 void IconEdit_RedoCommand(int WndNum){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	BYTE *pByte;
 	ICONEDIT_UNDOSTATE *pUndoState;
@@ -68,5 +66,4 @@
 void IconEdit_NoticeChanging(int WndNum){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	ICONEDIT_UNDOSTATE *pUndoState;
